//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private MQTLineAlertEmail[] cacheMQTLineAlertEmail = null;

        private static MQTLineAlertEmail checkMQTLineAlertEmail = new MQTLineAlertEmail();

        /// <summary>
        /// This indicator will alert crossovers for manually drawn lines. Alerts are reset with each new bar or when ManualReset input set to true. 
        /// </summary>
        /// <returns></returns>
        public MQTLineAlertEmail MQTLineAlertEmail(string alertMessage, bool changeLineColor, string emailFrom, string emailTo, Color lineColor, bool manualReset, bool sendEmail, string soundFile)
        {
            return MQTLineAlertEmail(Input, alertMessage, changeLineColor, emailFrom, emailTo, lineColor, manualReset, sendEmail, soundFile);
        }

        /// <summary>
        /// This indicator will alert crossovers for manually drawn lines. Alerts are reset with each new bar or when ManualReset input set to true. 
        /// </summary>
        /// <returns></returns>
        public MQTLineAlertEmail MQTLineAlertEmail(Data.IDataSeries input, string alertMessage, bool changeLineColor, string emailFrom, string emailTo, Color lineColor, bool manualReset, bool sendEmail, string soundFile)
        {
            if (cacheMQTLineAlertEmail != null)
                for (int idx = 0; idx < cacheMQTLineAlertEmail.Length; idx++)
                    if (cacheMQTLineAlertEmail[idx].AlertMessage == alertMessage && cacheMQTLineAlertEmail[idx].ChangeLineColor == changeLineColor && cacheMQTLineAlertEmail[idx].EmailFrom == emailFrom && cacheMQTLineAlertEmail[idx].EmailTo == emailTo && cacheMQTLineAlertEmail[idx].LineColor == lineColor && cacheMQTLineAlertEmail[idx].ManualReset == manualReset && cacheMQTLineAlertEmail[idx].SendEmail == sendEmail && cacheMQTLineAlertEmail[idx].SoundFile == soundFile && cacheMQTLineAlertEmail[idx].EqualsInput(input))
                        return cacheMQTLineAlertEmail[idx];

            lock (checkMQTLineAlertEmail)
            {
                checkMQTLineAlertEmail.AlertMessage = alertMessage;
                alertMessage = checkMQTLineAlertEmail.AlertMessage;
                checkMQTLineAlertEmail.ChangeLineColor = changeLineColor;
                changeLineColor = checkMQTLineAlertEmail.ChangeLineColor;
                checkMQTLineAlertEmail.EmailFrom = emailFrom;
                emailFrom = checkMQTLineAlertEmail.EmailFrom;
                checkMQTLineAlertEmail.EmailTo = emailTo;
                emailTo = checkMQTLineAlertEmail.EmailTo;
                checkMQTLineAlertEmail.LineColor = lineColor;
                lineColor = checkMQTLineAlertEmail.LineColor;
                checkMQTLineAlertEmail.ManualReset = manualReset;
                manualReset = checkMQTLineAlertEmail.ManualReset;
                checkMQTLineAlertEmail.SendEmail = sendEmail;
                sendEmail = checkMQTLineAlertEmail.SendEmail;
                checkMQTLineAlertEmail.SoundFile = soundFile;
                soundFile = checkMQTLineAlertEmail.SoundFile;

                if (cacheMQTLineAlertEmail != null)
                    for (int idx = 0; idx < cacheMQTLineAlertEmail.Length; idx++)
                        if (cacheMQTLineAlertEmail[idx].AlertMessage == alertMessage && cacheMQTLineAlertEmail[idx].ChangeLineColor == changeLineColor && cacheMQTLineAlertEmail[idx].EmailFrom == emailFrom && cacheMQTLineAlertEmail[idx].EmailTo == emailTo && cacheMQTLineAlertEmail[idx].LineColor == lineColor && cacheMQTLineAlertEmail[idx].ManualReset == manualReset && cacheMQTLineAlertEmail[idx].SendEmail == sendEmail && cacheMQTLineAlertEmail[idx].SoundFile == soundFile && cacheMQTLineAlertEmail[idx].EqualsInput(input))
                            return cacheMQTLineAlertEmail[idx];

                MQTLineAlertEmail indicator = new MQTLineAlertEmail();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AlertMessage = alertMessage;
                indicator.ChangeLineColor = changeLineColor;
                indicator.EmailFrom = emailFrom;
                indicator.EmailTo = emailTo;
                indicator.LineColor = lineColor;
                indicator.ManualReset = manualReset;
                indicator.SendEmail = sendEmail;
                indicator.SoundFile = soundFile;
                Indicators.Add(indicator);
                indicator.SetUp();

                MQTLineAlertEmail[] tmp = new MQTLineAlertEmail[cacheMQTLineAlertEmail == null ? 1 : cacheMQTLineAlertEmail.Length + 1];
                if (cacheMQTLineAlertEmail != null)
                    cacheMQTLineAlertEmail.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheMQTLineAlertEmail = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// This indicator will alert crossovers for manually drawn lines. Alerts are reset with each new bar or when ManualReset input set to true. 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.MQTLineAlertEmail MQTLineAlertEmail(string alertMessage, bool changeLineColor, string emailFrom, string emailTo, Color lineColor, bool manualReset, bool sendEmail, string soundFile)
        {
            return _indicator.MQTLineAlertEmail(Input, alertMessage, changeLineColor, emailFrom, emailTo, lineColor, manualReset, sendEmail, soundFile);
        }

        /// <summary>
        /// This indicator will alert crossovers for manually drawn lines. Alerts are reset with each new bar or when ManualReset input set to true. 
        /// </summary>
        /// <returns></returns>
        public Indicator.MQTLineAlertEmail MQTLineAlertEmail(Data.IDataSeries input, string alertMessage, bool changeLineColor, string emailFrom, string emailTo, Color lineColor, bool manualReset, bool sendEmail, string soundFile)
        {
            return _indicator.MQTLineAlertEmail(input, alertMessage, changeLineColor, emailFrom, emailTo, lineColor, manualReset, sendEmail, soundFile);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// This indicator will alert crossovers for manually drawn lines. Alerts are reset with each new bar or when ManualReset input set to true. 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.MQTLineAlertEmail MQTLineAlertEmail(string alertMessage, bool changeLineColor, string emailFrom, string emailTo, Color lineColor, bool manualReset, bool sendEmail, string soundFile)
        {
            return _indicator.MQTLineAlertEmail(Input, alertMessage, changeLineColor, emailFrom, emailTo, lineColor, manualReset, sendEmail, soundFile);
        }

        /// <summary>
        /// This indicator will alert crossovers for manually drawn lines. Alerts are reset with each new bar or when ManualReset input set to true. 
        /// </summary>
        /// <returns></returns>
        public Indicator.MQTLineAlertEmail MQTLineAlertEmail(Data.IDataSeries input, string alertMessage, bool changeLineColor, string emailFrom, string emailTo, Color lineColor, bool manualReset, bool sendEmail, string soundFile)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.MQTLineAlertEmail(input, alertMessage, changeLineColor, emailFrom, emailTo, lineColor, manualReset, sendEmail, soundFile);
        }
    }
}
#endregion
